#include <stdio.h>
#include <string>
#include <string.h>
#include <assert.h>
using namespace std;

bool ass(char c) {
  return (c >= 'a' && c <= 'z');
}

char v(char a, char b) {
  assert(ass(a) && ass(b));
  return (a-'a' + b-'a')%('{'-'a')+'a';
}

char inv(char a, char b) {
  assert(ass(a) && ass(b));
  return (a-'a' - (b-'a') + ('{'-'a'))%('{'-'a')+'a';
}

bool check_key(string k) {
  for (int i=0;i<k.size();i++)
    if (!ass(k.at(i))) return false;
  return true;
}

string encrypt(string p, string k) {
  int x = 0;
  string e;
  for(int i=0;i<p.size();i++) {
    char c = tolower(p.at(i));
    if (!ass(c)) continue;
    e.append(1,v(c,k.at(e.size()%k.size())));
  }
  return e;
}

string decrypt(string e, string k) {
  for (int i=0;i<e.size();i++) assert(ass(e.at(i)));
  int x = 0;
  string d;
  for(int i=0;i<e.size();i++) {
    d.append(1,inv(e.at(i), k.at(i%k.size())));
  }
  return d;
}

int main(int argc, char** argv) {
  if (argc != 4) {
    printf("Usage: %s key textfile command.\n", argv[0]);
    return 1;
  }
  string key(argv[1]);  
  if (!check_key(key)) {
    printf("Key %s invalid. Has to be lowercase string.\n", key.c_str());
    return 1;
  }
  FILE* f = fopen(argv[2], "r");
  if (!f) {
    printf("Could not open file %s.\n", argv[2]);
    return 1;
  }
  
  const int max_size = 1024*1024;
  char buf[max_size];
  fread(buf, 1, max_size, f);
  if (strcmp(argv[3], "encrypt") == 0) {
    printf("%s\n", encrypt(string(buf), key).c_str());
  } else if (strcmp(argv[3], "decrypt") == 0) {
    int l = strlen(buf);
    string s;
    for (int i=0;i<l;i++) {
      if (isalpha(buf[i])) s.append(1, buf[i]);
    }
    printf("%s\n", decrypt(s, key).c_str());
  } else {
    printf("Command %s not one of 'encrypt', 'decrypt'\n", argv[3]);
    return 1;
  }
}
